#!/bin/sh

set -e

MYSQL_PWD="`cat /etc/psa/.psa.shadow`"
export MYSQL_PWD

mysql_client=
for file in /usr/local/psa/mysql/bin/mysql /usr/local/bin/mysql /usr/bin/mysql; do
    if $file -uadmin psa </dev/null >/dev/null 2>&1; then
	mysql_client="$file"
	break
    fi
done

if [ -z "$mysql_client" ]; then
    echo "cannot connect to mysql database"
    exit 1
fi

psa_prefix=
for t in /opt/psa /usr/local/psa; do
    if [ -x "$t/admin/bin/php" ]; then
	psa_prefix="$t"
	break
    fi
done

if [ -z "$psa_prefix" ]; then
    echo "cannot found Plesk PHP engine"
    exit 1
fi

mysql="$mysql_client -uadmin -N -B -r psa" 

version="`cat /usr/local/psa/version | awk '{print $1}' | tr -d '.'`"

if [ "$version" -lt "900" ]; then
    num=`$mysql -e "SELECT id FROM key_history WHERE name IS NULL AND filename = '/etc/psa/psa.key' ORDER BY id ASC"`
    key_id=`$mysql -e "SELECT plesk_key_id FROM key_history WHERE id = $num"`
    key_pwd=`$mysql -e "SELECT options FROM key_history WHERE id = $num"`
    url="`/usr/local/psa/admin/bin/php -r 'echo "https://" . (iskeyprop("keyserver_host")?getkeyprop("keyserver_host"):"ka.parallels.com") . ":5224/\n";'
    `"
else
    url="`sw-engine -c /usr/local/psa/admin/conf/php.ini -r ' \
         require_once("common_func.php3"); \
	$key = of_get_key_by_product("plesk-unix"); \
	$url = $key?of_find_properties($key, SWKEY_CORE_NS, "license-server-url"):null; \
	 echo ($url?$url[0]:"https://ka.parallels.com:5224/") . "\n";' \
    `"

    key_id="`sw-engine -c /usr/local/psa/admin/conf/php.ini -r ' \
         require_once("common_func.php3"); \
         require_once("key/Key.php"); \
         $key = keyMaker(); \
	 echo $key->getProp("plesk_key_id"); \
    '`"

    key_num="`echo $key_id | perl -e '$str = <STDIN>; $str =~ s/(\.|\D)//g; print $str;'`"

    if [ "$key_num" -ne 0 ]; then
	key_pwd="`sw-engine -c /usr/local/psa/admin/conf/php.ini -r ' \
	     $res = of_find_properties(of_get_key_by_product("plesk-unix"), SWKEY_CORE_NS, "update-ticket"); \
	     echo $res[0]; \
	'`"

	if [ -z "$key_pwd" ]; then 
		key_pwd="`sw-engine -c /usr/local/psa/admin/conf/php.ini -r ' \
		     $res = of_find_properties(of_get_key_by_product("plesk-unix"), "http://swsoft.com/schemas/keys/core/2", \
		     "update-ticket"); \
		     echo $res[0]; \
		'`"
	fi
    fi
fi

echo "Key Info v1.0"
echo "PleskLogin"
echo "PleskPassword"
echo "$url"
echo "$key_id"
echo "$key_pwd"
